import { isObjectLike as r } from "../jsutils/isObjectLike.mjs";

import { getLocation as o } from "../language/location.mjs";

import { printLocation as e, printSourceLocation as t, printLocation$1 as i, printSourceLocation$1 as n } from "../language/printLocation.mjs";

var a = function(i) {
  function GraphQLError(e, t, n, a, l, s, u) {
    var c, f, p, v;
    i.call(this, e);
    var h = Array.isArray(t) ? 0 !== t.length ? t : void 0 : t ? [ t ] : void 0;
    var d = n;
    if (!d && h) {
      var g;
      d = null === (g = h[0].loc) || void 0 === g ? void 0 : g.source;
    }
    var E;
    if (a) {
      E = a;
    } else if (h) {
      E = [];
      for (var m = 0, L = h; m < L.length; m += 1) {
        var b = L[m];
        if (b.loc) {
          E.push(b.loc.start);
        }
      }
    }
    if (E && 0 === E.length) {
      E = void 0;
    }
    var G;
    if (a && n) {
      G = a.map((function(r) {
        return o(n, r);
      }));
    } else if (h) {
      G = [];
      for (var Q = 0, j = h; Q < j.length; Q += 1) {
        var k = j[Q];
        if (k.loc) {
          G.push(o(k.loc.source, k.loc.start));
        }
      }
    }
    var y = u;
    if (null == y && null != s) {
      var O = s.extensions;
      if (r(O)) {
        y = O;
      }
    }
    Object.defineProperties(this, {
      name: {
        value: "GraphQLError"
      },
      message: {
        value: e,
        enumerable: !0,
        writable: !0
      },
      locations: {
        value: null !== (c = G) && void 0 !== c ? c : void 0,
        enumerable: null != G
      },
      path: {
        value: null != l ? l : void 0,
        enumerable: null != l
      },
      nodes: {
        value: null != h ? h : void 0
      },
      source: {
        value: null !== (f = d) && void 0 !== f ? f : void 0
      },
      positions: {
        value: null !== (p = E) && void 0 !== p ? p : void 0
      },
      originalError: {
        value: s
      },
      extensions: {
        value: null !== (v = y) && void 0 !== v ? v : void 0,
        enumerable: null != y
      }
    });
    if (null != s && s.stack) {
      Object.defineProperty(this, "stack", {
        value: s.stack,
        writable: !0,
        configurable: !0
      });
      return;
    }
    if (i.captureStackTrace) {
      i.captureStackTrace(this, GraphQLError);
    } else {
      Object.defineProperty(this, "stack", {
        value: i().stack,
        writable: !0,
        configurable: !0
      });
    }
  }
  if (i) {
    GraphQLError.__proto__ = i;
  }
  (GraphQLError.prototype = Object.create(i && i.prototype)).constructor = GraphQLError;
  GraphQLError.prototype.toString = function toString() {
    return function printError$1(r) {
      var o = r.message;
      if (r.nodes) {
        for (var i = 0, n = r.nodes; i < n.length; i += 1) {
          var a = n[i];
          if (a.loc) {
            o += "\n\n" + e(a.loc);
          }
        }
      } else if (r.source && r.locations) {
        for (var l = 0, s = r.locations; l < s.length; l += 1) {
          o += "\n\n" + t(r.source, s[l]);
        }
      }
      return o;
    }(this);
  };
  return GraphQLError;
}(Error);

var l = function(r) {
  function GraphQLError(o, e, t, i, n, a, l) {
    r.call(this, o);
    this.name = "GraphQLError";
    this.message = o;
    if (n) {
      this.path = n;
    }
    if (e) {
      this.nodes = e;
    }
    if (t) {
      this.source = t;
    }
    if (i) {
      this.positions = i;
    }
    if (a) {
      this.originalError = a;
    }
    var s = l;
    if (null == s && null != a) {
      var u = a.extensions;
      if (isObjectLike(u)) {
        s = u;
      }
    }
    if (s) {
      this.extensions = s;
    }
  }
  if (r) {
    GraphQLError.__proto__ = r;
  }
  (GraphQLError.prototype = Object.create(r && r.prototype)).constructor = GraphQLError;
  GraphQLError.prototype.toString = function toString() {
    return printError(this);
  };
  return GraphQLError;
}(Error);

function printError(r) {
  var o = r.message;
  if (r.nodes) {
    for (var e = 0, t = r.nodes; e < t.length; e += 1) {
      var a = t[e];
      if (a.loc) {
        o += "\n\n" + i(a.loc);
      }
    }
  } else if (r.source && r.locations) {
    for (var l = 0, s = r.locations; l < s.length; l += 1) {
      o += "\n\n" + n(r.source, s[l]);
    }
  }
  return o;
}

export { l as GraphQLError, a as GraphQLError$1, printError };
