"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var r = require("../jsutils/isObjectLike.js");

var o = require("../language/location.js");

var e = require("../language/printLocation.js");

var t = function(t) {
  function GraphQLError(e, i, n, a, l, s, u) {
    var c, p, v, f;
    t.call(this, e);
    var h = Array.isArray(i) ? 0 !== i.length ? i : void 0 : i ? [ i ] : void 0;
    var L = n;
    if (!L && h) {
      var d;
      L = null === (d = h[0].loc) || void 0 === d ? void 0 : d.source;
    }
    var g;
    if (a) {
      g = a;
    } else if (h) {
      g = [];
      for (var E = 0, b = h; E < b.length; E += 1) {
        var G = b[E];
        if (G.loc) {
          g.push(G.loc.start);
        }
      }
    }
    if (g && 0 === g.length) {
      g = void 0;
    }
    var Q;
    if (a && n) {
      Q = a.map((function(r) {
        return o.getLocation(n, r);
      }));
    } else if (h) {
      Q = [];
      for (var j = 0, m = h; j < m.length; j += 1) {
        var y = m[j];
        if (y.loc) {
          Q.push(o.getLocation(y.loc.source, y.loc.start));
        }
      }
    }
    var k = u;
    if (null == k && null != s) {
      var _ = s.extensions;
      if (r.isObjectLike(_)) {
        k = _;
      }
    }
    Object.defineProperties(this, {
      name: {
        value: "GraphQLError"
      },
      message: {
        value: e,
        enumerable: !0,
        writable: !0
      },
      locations: {
        value: null !== (c = Q) && void 0 !== c ? c : void 0,
        enumerable: null != Q
      },
      path: {
        value: null != l ? l : void 0,
        enumerable: null != l
      },
      nodes: {
        value: null != h ? h : void 0
      },
      source: {
        value: null !== (p = L) && void 0 !== p ? p : void 0
      },
      positions: {
        value: null !== (v = g) && void 0 !== v ? v : void 0
      },
      originalError: {
        value: s
      },
      extensions: {
        value: null !== (f = k) && void 0 !== f ? f : void 0,
        enumerable: null != k
      }
    });
    if (null != s && s.stack) {
      Object.defineProperty(this, "stack", {
        value: s.stack,
        writable: !0,
        configurable: !0
      });
      return;
    }
    if (t.captureStackTrace) {
      t.captureStackTrace(this, GraphQLError);
    } else {
      Object.defineProperty(this, "stack", {
        value: t().stack,
        writable: !0,
        configurable: !0
      });
    }
  }
  if (t) {
    GraphQLError.__proto__ = t;
  }
  (GraphQLError.prototype = Object.create(t && t.prototype)).constructor = GraphQLError;
  GraphQLError.prototype.toString = function toString() {
    return function printError$1(r) {
      var o = r.message;
      if (r.nodes) {
        for (var t = 0, i = r.nodes; t < i.length; t += 1) {
          var n = i[t];
          if (n.loc) {
            o += "\n\n" + e.printLocation(n.loc);
          }
        }
      } else if (r.source && r.locations) {
        for (var a = 0, l = r.locations; a < l.length; a += 1) {
          o += "\n\n" + e.printSourceLocation(r.source, l[a]);
        }
      }
      return o;
    }(this);
  };
  return GraphQLError;
}(Error);

var i = function(r) {
  function GraphQLError(o, e, t, i, n, a, l) {
    r.call(this, o);
    this.name = "GraphQLError";
    this.message = o;
    if (n) {
      this.path = n;
    }
    if (e) {
      this.nodes = e;
    }
    if (t) {
      this.source = t;
    }
    if (i) {
      this.positions = i;
    }
    if (a) {
      this.originalError = a;
    }
    var s = l;
    if (null == s && null != a) {
      var u = a.extensions;
      if (isObjectLike(u)) {
        s = u;
      }
    }
    if (s) {
      this.extensions = s;
    }
  }
  if (r) {
    GraphQLError.__proto__ = r;
  }
  (GraphQLError.prototype = Object.create(r && r.prototype)).constructor = GraphQLError;
  GraphQLError.prototype.toString = function toString() {
    return printError(this);
  };
  return GraphQLError;
}(Error);

function printError(r) {
  var o = r.message;
  if (r.nodes) {
    for (var t = 0, i = r.nodes; t < i.length; t += 1) {
      var n = i[t];
      if (n.loc) {
        o += "\n\n" + e.printLocation$1(n.loc);
      }
    }
  } else if (r.source && r.locations) {
    for (var a = 0, l = r.locations; a < l.length; a += 1) {
      o += "\n\n" + e.printSourceLocation$1(r.source, l[a]);
    }
  }
  return o;
}

exports.GraphQLError = i;

exports.GraphQLError$1 = t;

exports.printError = printError;
