"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var n = require("./kinds.js");

var e = require("../error/GraphQLError.js");

var r = "boolean" == typeof /./g.sticky;

function E(n) {
  return "function" == typeof n ? function B(n) {
    return n.length ? n : function(e) {
      return n()(e);
    };
  }(n) : "string" == typeof n ? function C(n) {
    return function(e) {
      if (e.x < e.quasis.length) {
        for (var r = e.quasis[e.x], l = 0, i = n.length; l < i; l++) {
          if (r.charCodeAt(e.y + l) !== n.charCodeAt(l)) {
            return null;
          }
        }
        e.y += n.length;
        return n;
      }
    };
  }(n) : function D(n) {
    n = r ? new RegExp(n.source, "y") : new RegExp(n.source + "|()", "g");
    return function(e) {
      if (e.x < e.quasis.length) {
        var l = e.quasis[e.x];
        n.lastIndex = e.y;
        var i;
        r ? n.test(l) && (i = l.slice(e.y, n.lastIndex)) : null == (l = n.exec(l))[1] && (i = l[0]);
        e.y = n.lastIndex;
        return i;
      }
    };
  }(n);
}

function parse$1(n) {
  return function(e) {
    var r = arguments;
    for (var l = [], i = arguments.length - 1; 0 < i--; ) {
      l[i] = r[i + 1];
    }
    "string" == typeof e && (e = [ e ]);
    return n({
      quasis: e,
      expressions: l,
      x: 0,
      y: 0
    });
  };
}

var l = E(/[_\w][_\d\w]*/);

var name = function(e) {
  var r = e.y, i = e.x;
  var a = [];
  var u;
  if (null != (u = l(e))) {
    a.push(u);
  } else {
    e.y = r;
    e.x = i;
    return {
      kind: a.tag,
      value: a[0]
    };
  }
  if (n.Kind.NAME) {
    a.tag = n.Kind.NAME;
  }
  return {
    kind: a.tag,
    value: a[0]
  };
};

var i = E("null");

var a = E(/true|false/);

var u = E("$");

var variable = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  if (null == u(e)) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0]
    };
  }
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0]
    };
  }
  if (n.Kind.VARIABLE) {
    i.tag = n.Kind.VARIABLE;
  }
  return {
    kind: i.tag,
    name: i[0]
  };
};

var t = E(/[-]?\d+/), y = E(/[.]\d+/), s = E(/[eE][+-]?\d+/);

var x = E('"""'), v = E(/.*(?=""")/), f = E('"""'), d = E('"'), g = E(/[^"\r\n]*/), o = E('"');

var k = E("["), h = E(/([\s,]|#[^\n\r]+)+/), p = E("]");

var c = E(":");

var objectField = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      value: i[1]
    };
  }
  var y = e.y, s = e.x;
  if (null == (a = h(e))) {
    e.y = y;
    e.x = s;
  }
  if (null == (a = c(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      value: i[1]
    };
  }
  if (null != (a = value(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      value: i[1]
    };
  }
  if (n.Kind.OBJECT_FIELD) {
    i.tag = n.Kind.OBJECT_FIELD;
  }
  return {
    kind: i.tag,
    name: i[0],
    value: i[1]
  };
};

var b = E("{"), N = E("}");

var value = function(e) {
  var r = e.y, l = e.x;
  var u = [];
  var c;
  var I = e.y, K = e.x;
  if (null == (c = h(e))) {
    e.y = I;
    e.x = K;
  }
  var T = u.length;
  n: {
    e: {
      var m = e.y, A = e.x;
      if (null != (c = function(e) {
        var r = e.y, l = e.x;
        var a = [];
        var u;
        if (null != (u = i(e))) {
          a.push(u);
        } else {
          e.y = r;
          e.x = l;
          return {
            kind: a.tag
          };
        }
        if (n.Kind.NULL) {
          a.tag = n.Kind.NULL;
        }
        return {
          kind: a.tag
        };
      }(e))) {
        u.push(c);
      } else {
        e.y = m;
        e.x = A;
        u.length = T;
        break e;
      }
      break n;
    }
    e: {
      m = e.y, A = e.x;
      if (null != (c = function(e) {
        var r = e.y, l = e.x;
        var i = [];
        var u;
        if (null != (u = a(e))) {
          i.push(u);
        } else {
          e.y = r;
          e.x = l;
          return {
            kind: i.tag,
            value: "true" === i[0]
          };
        }
        if (n.Kind.BOOLEAN) {
          i.tag = n.Kind.BOOLEAN;
        }
        return {
          kind: i.tag,
          value: "true" === i[0]
        };
      }(e))) {
        u.push(c);
      } else {
        e.y = m;
        e.x = A;
        u.length = T;
        break e;
      }
      break n;
    }
    e: {
      m = e.y, A = e.x;
      if (null != (c = variable(e))) {
        u.push(c);
      } else {
        e.y = m;
        e.x = A;
        u.length = T;
        break e;
      }
      break n;
    }
    e: {
      m = e.y, A = e.x;
      if (null != (c = function(e) {
        var r = e.y, l = e.x;
        var i = [];
        var a;
        r: {
          l: {
            var u = e.y, t = e.x;
            var y = i.length;
            if (null == (a = x(e))) {
              e.y = u;
              e.x = t;
              i.length = y;
              break l;
            }
            if (null != (a = v(e))) {
              i.push(a);
            } else {
              e.y = u;
              e.x = t;
              i.length = y;
              break l;
            }
            if (null == (a = f(e))) {
              e.y = u;
              e.x = t;
              i.length = y;
              break l;
            }
            break r;
          }
          y = i.length;
          if (null == (a = d(e))) {
            e.y = r;
            e.x = l;
            i.length = y;
            return {
              kind: i.tag,
              value: i[0]
            };
          }
          if (null != (a = g(e))) {
            i.push(a);
          } else {
            e.y = r;
            e.x = l;
            i.length = y;
            return {
              kind: i.tag,
              value: i[0]
            };
          }
          if (null == (a = o(e))) {
            e.y = r;
            e.x = l;
            i.length = y;
            return {
              kind: i.tag,
              value: i[0]
            };
          }
        }
        if (n.Kind.STRING) {
          i.tag = n.Kind.STRING;
        }
        return {
          kind: i.tag,
          value: i[0]
        };
      }(e))) {
        u.push(c);
      } else {
        e.y = m;
        e.x = A;
        u.length = T;
        break e;
      }
      break n;
    }
    e: {
      m = e.y, A = e.x;
      if (null != (c = function(e) {
        var r = e.y, l = e.x;
        var i = [];
        var a;
        if (null != (a = t(e))) {
          i.push(a);
        } else {
          e.y = r;
          e.x = l;
          return {
            kind: 1 === i.length ? n.Kind.INT : n.Kind.FLOAT,
            value: i.join("")
          };
        }
        var u = e.y, x = e.x;
        if (null != (a = y(e))) {
          i.push(a);
        } else {
          e.y = u;
          e.x = x;
        }
        u = e.y, x = e.x;
        if (null != (a = s(e))) {
          i.push(a);
        } else {
          e.y = u;
          e.x = x;
        }
        return {
          kind: 1 === i.length ? n.Kind.INT : n.Kind.FLOAT,
          value: i.join("")
        };
      }(e))) {
        u.push(c);
      } else {
        e.y = m;
        e.x = A;
        u.length = T;
        break e;
      }
      break n;
    }
    e: {
      m = e.y, A = e.x;
      if (null != (c = function(e) {
        var r = e.y, l = e.x;
        var i = [];
        var a;
        if (null != (a = name(e))) {
          i.push(a);
        } else {
          e.y = r;
          e.x = l;
          return {
            kind: i.tag,
            value: i[0].value
          };
        }
        if (n.Kind.ENUM) {
          i.tag = n.Kind.ENUM;
        }
        return {
          kind: i.tag,
          value: i[0].value
        };
      }(e))) {
        u.push(c);
      } else {
        e.y = m;
        e.x = A;
        u.length = T;
        break e;
      }
      break n;
    }
    e: {
      m = e.y, A = e.x;
      if (null != (c = function(e) {
        var r = e.y, l = e.x;
        var i = [];
        var a;
        if (null == (a = k(e))) {
          e.y = r;
          e.x = l;
          return {
            kind: i.tag,
            values: i.slice()
          };
        }
        r: for (;;) {
          var u = e.y, t = e.x;
          if (null != (a = value(e))) {
            i.push(a);
          } else {
            e.y = u;
            e.x = t;
            break r;
          }
        }
        var y = e.y, s = e.x;
        if (null == (a = h(e))) {
          e.y = y;
          e.x = s;
        }
        if (null == (a = p(e))) {
          e.y = r;
          e.x = l;
          return {
            kind: i.tag,
            values: i.slice()
          };
        }
        y = e.y, s = e.x;
        if (null == (a = h(e))) {
          e.y = y;
          e.x = s;
        }
        if (n.Kind.LIST) {
          i.tag = n.Kind.LIST;
        }
        return {
          kind: i.tag,
          values: i.slice()
        };
      }(e))) {
        u.push(c);
      } else {
        e.y = m;
        e.x = A;
        u.length = T;
        break e;
      }
      break n;
    }
    if (null != (c = function(e) {
      var r = e.y, l = e.x;
      var i = [];
      var a;
      if (null == (a = b(e))) {
        e.y = r;
        e.x = l;
        return {
          kind: i.tag,
          fields: i.slice()
        };
      }
      e: for (;;) {
        var u = e.y, t = e.x;
        if (null != (a = objectField(e))) {
          i.push(a);
        } else {
          e.y = u;
          e.x = t;
          break e;
        }
      }
      if (null == (a = N(e))) {
        e.y = r;
        e.x = l;
        return {
          kind: i.tag,
          fields: i.slice()
        };
      }
      var y = e.y, s = e.x;
      if (null == (a = h(e))) {
        e.y = y;
        e.x = s;
      }
      if (n.Kind.OBJECT) {
        i.tag = n.Kind.OBJECT;
      }
      return {
        kind: i.tag,
        fields: i.slice()
      };
    }(e))) {
      u.push(c);
    } else {
      e.y = r;
      e.x = l;
      u.length = T;
      return;
    }
  }
  I = e.y, K = e.x;
  if (null == (c = h(e))) {
    e.y = I;
    e.x = K;
  }
  return function(n) {
    return n[0];
  }(u);
};

var I = E(":");

var arg = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      value: i[1]
    };
  }
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null == (a = I(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      value: i[1]
    };
  }
  u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null != (a = value(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      value: i[1]
    };
  }
  if (n.Kind.ARGUMENT) {
    i.tag = n.Kind.ARGUMENT;
  }
  return {
    kind: i.tag,
    name: i[0],
    value: i[1]
  };
};

var K = E("("), T = E(")");

var args = function(n) {
  var e = [];
  var r;
  var l = n.y, i = n.x;
  if (null == (r = h(n))) {
    n.y = l;
    n.x = i;
  }
  n: {
    l = n.y, i = n.x;
    var a = e.length;
    if (null == (r = K(n))) {
      n.y = l;
      n.x = i;
      e.length = a;
      break n;
    }
    var u = n.y, t = n.x;
    if (null == (r = h(n))) {
      n.y = u;
      n.x = t;
    }
    if (null != (r = arg(n))) {
      e.push(r);
    } else {
      n.y = l;
      n.x = i;
      e.length = a;
      break n;
    }
    e: for (;;) {
      var y = n.y, s = n.x;
      if (null != (r = arg(n))) {
        e.push(r);
      } else {
        n.y = y;
        n.x = s;
        break e;
      }
    }
    if (null == (r = T(n))) {
      n.y = l;
      n.x = i;
      e.length = a;
      break n;
    }
    u = n.y, t = n.x;
    if (null == (r = h(n))) {
      n.y = u;
      n.x = t;
    }
  }
  return e;
};

var m = E("@");

var directive = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  if (null == (a = m(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      arguments: i[1]
    };
  }
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      arguments: i[1]
    };
  }
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  u = e.y, t = e.x;
  if (null != (a = args(e))) {
    i.push(a);
  } else {
    e.y = u;
    e.x = t;
  }
  u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (n.Kind.DIRECTIVE) {
    i.tag = n.Kind.DIRECTIVE;
  }
  return {
    kind: i.tag,
    name: i[0],
    arguments: i[1]
  };
};

var directives = function(n) {
  var e = [];
  var r;
  var l = n.y, i = n.x;
  if (null == (r = h(n))) {
    n.y = l;
    n.x = i;
  }
  n: for (;;) {
    l = n.y, i = n.x;
    if (null != (r = directive(n))) {
      e.push(r);
    } else {
      n.y = l;
      n.x = i;
      break n;
    }
  }
  return e;
};

var A = E(":");

var field = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  n: {
    u = e.y, t = e.x;
    var y = i.length;
    var s = e.y, x = e.x;
    if (null == (a = h(e))) {
      e.y = s;
      e.x = x;
    }
    if (null == (a = A(e))) {
      e.y = u;
      e.x = t;
      i.length = y;
      break n;
    }
    s = e.y, x = e.x;
    if (null == (a = h(e))) {
      e.y = s;
      e.x = x;
    }
    if (null != (a = name(e))) {
      i.push(a);
    } else {
      e.y = u;
      e.x = t;
      i.length = y;
      break n;
    }
  }
  if (null != (a = args(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  if (null != (a = directives(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  u = e.y, t = e.x;
  if (null != (a = selectionSet(e))) {
    i.push(a);
  } else {
    e.y = u;
    e.x = t;
  }
  if (n.Kind.FIELD) {
    i.tag = n.Kind.FIELD;
  }
  return function(e) {
    var r = 0;
    return {
      kind: e.tag,
      alias: e[1].kind === n.Kind.NAME ? e[r++] : void 0,
      name: e[r++],
      arguments: e[r++],
      directives: e[r++],
      selectionSet: e[r++]
    };
  }(i);
};

var O = E("["), L = E("]"), _ = E("!");

var type = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  var u = i.length;
  n: {
    e: {
      var t = e.y, y = e.x;
      if (null == (a = O(e))) {
        e.y = t;
        e.x = y;
        i.length = u;
        break e;
      }
      var s = e.y, x = e.x;
      if (null == (a = h(e))) {
        e.y = s;
        e.x = x;
      }
      if (null != (a = type(e))) {
        i.push(a);
      } else {
        e.y = t;
        e.x = y;
        i.length = u;
        break e;
      }
      s = e.y, x = e.x;
      if (null == (a = h(e))) {
        e.y = s;
        e.x = x;
      }
      if (null == (a = L(e))) {
        e.y = t;
        e.x = y;
        i.length = u;
        break e;
      }
      s = e.y, x = e.x;
      if (null == (a = h(e))) {
        e.y = s;
        e.x = x;
      }
      break n;
    }
    if (null != (a = name(e))) {
      i.push(a);
    } else {
      e.y = r;
      e.x = l;
      i.length = u;
      return;
    }
  }
  var v = e.y, f = e.x;
  if (null != (a = _(e))) {
    i.push(a);
  } else {
    e.y = v;
    e.x = f;
  }
  v = e.y, f = e.x;
  if (null == (a = h(e))) {
    e.y = v;
    e.x = f;
  }
  return function(e) {
    var r = "Name" === e[0].kind ? {
      kind: n.Kind.NAMED_TYPE,
      name: e[0]
    } : {
      kind: n.Kind.LIST_TYPE,
      type: e[0]
    };
    return "!" === e[1] ? {
      kind: n.Kind.NON_NULL_TYPE,
      type: r
    } : r;
  }(i);
};

var S = E("on");

var typeCondition = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null == (a = S(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: n.Kind.NAMED_TYPE,
      name: i[0]
    };
  }
  if (null == (a = h(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: n.Kind.NAMED_TYPE,
      name: i[0]
    };
  }
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: n.Kind.NAMED_TYPE,
      name: i[0]
    };
  }
  var y = e.y, s = e.x;
  if (null == (a = h(e))) {
    e.y = y;
    e.x = s;
  }
  return {
    kind: n.Kind.NAMED_TYPE,
    name: i[0]
  };
};

var R = E("...");

var inlineFragment = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  if (null == (a = R(e))) {
    e.y = r;
    e.x = l;
    return;
  }
  var u = e.y, t = e.x;
  if (null != (a = typeCondition(e))) {
    i.push(a);
  } else {
    e.y = u;
    e.x = t;
  }
  if (null != (a = directives(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  if (null != (a = selectionSet(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  if (n.Kind.INLINE_FRAGMENT) {
    i.tag = n.Kind.INLINE_FRAGMENT;
  }
  return function(e) {
    var r = 0;
    return {
      kind: e.tag,
      typeCondition: e[r].kind === n.Kind.NAMED_TYPE ? e[r++] : void 0,
      directives: e[r++],
      selectionSet: e[r]
    };
  }(i);
};

var M = E("..."), F = E("on");

var fragmentSpread = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  if (null == (a = M(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      directives: i[1]
    };
  }
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  n: {
    var y = e.y, s = e.x;
    if (null == (a = F(e))) {
      e.y = y;
      e.x = s;
      break n;
    }
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      directives: i[1]
    };
  }
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      directives: i[1]
    };
  }
  y = e.y, s = e.x;
  if (null == (a = h(e))) {
    e.y = y;
    e.x = s;
  }
  if (null != (a = directives(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      directives: i[1]
    };
  }
  if (n.Kind.FRAGMENT_SPREAD) {
    i.tag = n.Kind.FRAGMENT_SPREAD;
  }
  return {
    kind: i.tag,
    name: i[0],
    directives: i[1]
  };
};

var P = E("{"), G = E("}");

var selectionSet = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null == (a = P(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      selections: i.slice()
    };
  }
  var y = e.y, s = e.x;
  if (null == (a = h(e))) {
    e.y = y;
    e.x = s;
  }
  var x = i.length;
  n: {
    e: {
      y = e.y, s = e.x;
      if (null != (a = inlineFragment(e))) {
        i.push(a);
      } else {
        e.y = y;
        e.x = s;
        i.length = x;
        break e;
      }
      break n;
    }
    e: {
      y = e.y, s = e.x;
      if (null != (a = fragmentSpread(e))) {
        i.push(a);
      } else {
        e.y = y;
        e.x = s;
        i.length = x;
        break e;
      }
      break n;
    }
    if (null != (a = field(e))) {
      i.push(a);
    } else {
      e.y = r;
      e.x = l;
      i.length = x;
      return {
        kind: i.tag,
        selections: i.slice()
      };
    }
  }
  n: for (;;) {
    u = e.y, t = e.x;
    x = i.length;
    e: {
      r: {
        y = e.y, s = e.x;
        if (null != (a = inlineFragment(e))) {
          i.push(a);
        } else {
          e.y = y;
          e.x = s;
          i.length = x;
          break r;
        }
        break e;
      }
      r: {
        y = e.y, s = e.x;
        if (null != (a = fragmentSpread(e))) {
          i.push(a);
        } else {
          e.y = y;
          e.x = s;
          i.length = x;
          break r;
        }
        break e;
      }
      if (null != (a = field(e))) {
        i.push(a);
      } else {
        e.y = u;
        e.x = t;
        i.length = x;
        break n;
      }
    }
  }
  if (null == (a = G(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      selections: i.slice()
    };
  }
  y = e.y, s = e.x;
  if (null == (a = h(e))) {
    e.y = y;
    e.x = s;
  }
  if (n.Kind.SELECTION_SET) {
    i.tag = n.Kind.SELECTION_SET;
  }
  return {
    kind: i.tag,
    selections: i.slice()
  };
};

var V = E("=");

var q = E(":");

var varDefinition = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  if (null != (a = variable(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      variable: i[0],
      type: i[1],
      defaultValue: i[2].kind ? i[2] : void 0,
      directives: !i[2].kind ? i[2] : i[3]
    };
  }
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null == (a = q(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      variable: i[0],
      type: i[1],
      defaultValue: i[2].kind ? i[2] : void 0,
      directives: !i[2].kind ? i[2] : i[3]
    };
  }
  u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null != (a = type(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      variable: i[0],
      type: i[1],
      defaultValue: i[2].kind ? i[2] : void 0,
      directives: !i[2].kind ? i[2] : i[3]
    };
  }
  var y = e.y, s = e.x;
  if (null != (a = function(n) {
    var e = n.y, r = n.x;
    var l = [];
    var i;
    if (null == V(n)) {
      n.y = e;
      n.x = r;
      return;
    }
    var a = n.y, u = n.x;
    if (null == h(n)) {
      n.y = a;
      n.x = u;
    }
    if (null != (i = value(n))) {
      l.push(i);
    } else {
      n.y = e;
      n.x = r;
      return;
    }
    return function(n) {
      return n[0];
    }(l);
  }(e))) {
    i.push(a);
  } else {
    e.y = y;
    e.x = s;
  }
  if (null != (a = directives(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      variable: i[0],
      type: i[1],
      defaultValue: i[2].kind ? i[2] : void 0,
      directives: !i[2].kind ? i[2] : i[3]
    };
  }
  y = e.y, s = e.x;
  if (null == (a = h(e))) {
    e.y = y;
    e.x = s;
  }
  if (n.Kind.VARIABLE_DEFINITION) {
    i.tag = n.Kind.VARIABLE_DEFINITION;
  }
  return {
    kind: i.tag,
    variable: i[0],
    type: i[1],
    defaultValue: i[2].kind ? i[2] : void 0,
    directives: !i[2].kind ? i[2] : i[3]
  };
};

var w = E("("), U = E(")");

var Y = E("fragment");

var fragmentDefinition = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null == (a = Y(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      typeCondition: i[1],
      directives: i[2],
      selectionSet: i[3]
    };
  }
  if (null == (a = h(e))) {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      typeCondition: i[1],
      directives: i[2],
      selectionSet: i[3]
    };
  }
  if (null != (a = name(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      typeCondition: i[1],
      directives: i[2],
      selectionSet: i[3]
    };
  }
  if (null != (a = typeCondition(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      typeCondition: i[1],
      directives: i[2],
      selectionSet: i[3]
    };
  }
  if (null != (a = directives(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      typeCondition: i[1],
      directives: i[2],
      selectionSet: i[3]
    };
  }
  if (null != (a = selectionSet(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      name: i[0],
      typeCondition: i[1],
      directives: i[2],
      selectionSet: i[3]
    };
  }
  if (n.Kind.FRAGMENT_DEFINITION) {
    i.tag = n.Kind.FRAGMENT_DEFINITION;
  }
  return {
    kind: i.tag,
    name: i[0],
    typeCondition: i[1],
    directives: i[2],
    selectionSet: i[3]
  };
};

var $ = E(/query|mutation|subscription/);

var operationDefinition = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  var u = e.y, t = e.x;
  if (null == (a = h(e))) {
    e.y = u;
    e.x = t;
  }
  if (null != (a = $(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  n: {
    u = e.y, t = e.x;
    var y = i.length;
    if (null == (a = h(e))) {
      e.y = u;
      e.x = t;
      i.length = y;
      break n;
    }
    if (null != (a = name(e))) {
      i.push(a);
    } else {
      e.y = u;
      e.x = t;
      i.length = y;
      break n;
    }
  }
  u = e.y, t = e.x;
  if (null != (a = function(n) {
    var e = n.y, r = n.x;
    var l = [];
    var i;
    var a = n.y, u = n.x;
    if (null == (i = h(n))) {
      n.y = a;
      n.x = u;
    }
    if (null == (i = w(n))) {
      n.y = e;
      n.x = r;
      return;
    }
    var t = n.y, y = n.x;
    if (null == (i = h(n))) {
      n.y = t;
      n.x = y;
    }
    if (null != (i = varDefinition(n))) {
      l.push(i);
    } else {
      n.y = e;
      n.x = r;
      return;
    }
    n: for (;;) {
      a = n.y, u = n.x;
      if (null != (i = varDefinition(n))) {
        l.push(i);
      } else {
        n.y = a;
        n.x = u;
        break n;
      }
    }
    if (null == (i = U(n))) {
      n.y = e;
      n.x = r;
      return;
    }
    t = n.y, y = n.x;
    if (null == (i = h(n))) {
      n.y = t;
      n.x = y;
    }
    l.tag = "vars";
    return l;
  }(e))) {
    i.push(a);
  } else {
    e.y = u;
    e.x = t;
  }
  if (null != (a = directives(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  if (null != (a = selectionSet(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return;
  }
  if (n.Kind.OPERATION_DEFINITION) {
    i.tag = n.Kind.OPERATION_DEFINITION;
  }
  return function(e) {
    var r = 1;
    return {
      kind: e.tag,
      operation: e[0],
      name: e[r].kind === n.Kind.NAME ? e[r++] : void 0,
      variableDefinitions: "vars" === e[r].tag ? e[r++].slice() : [],
      directives: e[r++],
      selectionSet: e[r]
    };
  }(i);
};

var queryShorthand = function(e) {
  var r = e.y, l = e.x;
  var i = [];
  var a;
  if (null != (a = selectionSet(e))) {
    i.push(a);
  } else {
    e.y = r;
    e.x = l;
    return {
      kind: i.tag,
      operation: "query",
      name: void 0,
      variableDefinitions: [],
      directives: [],
      selectionSet: i[0]
    };
  }
  if (n.Kind.OPERATION_DEFINITION) {
    i.tag = n.Kind.OPERATION_DEFINITION;
  }
  return {
    kind: i.tag,
    operation: "query",
    name: void 0,
    variableDefinitions: [],
    directives: [],
    selectionSet: i[0]
  };
};

var j = parse$1((function(e) {
  var r = [];
  var l;
  n: for (;;) {
    var i = e.y, a = e.x;
    var u = r.length;
    e: {
      r: {
        var t = e.y, y = e.x;
        if (null != (l = queryShorthand(e))) {
          r.push(l);
        } else {
          e.y = t;
          e.x = y;
          r.length = u;
          break r;
        }
        break e;
      }
      r: {
        t = e.y, y = e.x;
        if (null != (l = operationDefinition(e))) {
          r.push(l);
        } else {
          e.y = t;
          e.x = y;
          r.length = u;
          break r;
        }
        break e;
      }
      if (null != (l = fragmentDefinition(e))) {
        r.push(l);
      } else {
        e.y = i;
        e.x = a;
        r.length = u;
        break n;
      }
    }
  }
  if (n.Kind.DOCUMENT) {
    r.tag = n.Kind.DOCUMENT;
  }
  return function(n) {
    return n.length ? {
      kind: n.tag,
      definitions: n.slice()
    } : void 0;
  }(r);
}));

var J = parse$1(value);

var Q = parse$1(type);

exports.parse = function parse(n) {
  var r = j(n);
  if (null == r) {
    throw new e.GraphQLError$1("Syntax Error");
  }
  return r;
};

exports.parseType = function parseType(n) {
  var r = Q(n);
  if (null == r) {
    throw new e.GraphQLError$1("Syntax Error");
  }
  return r;
};

exports.parseValue = function parseValue(n) {
  var r = J(n);
  if (null == r) {
    throw new e.GraphQLError$1("Syntax Error");
  }
  return r;
};
