import { Kind as e } from "./kinds.mjs";

import { GraphQLError$1 as n } from "../error/GraphQLError.mjs";

var r = "boolean" == typeof /./g.sticky;

function E(e) {
  return "function" == typeof e ? function B(e) {
    return e.length ? e : function(n) {
      return e()(n);
    };
  }(e) : "string" == typeof e ? function C(e) {
    return function(n) {
      if (n.x < n.quasis.length) {
        for (var r = n.quasis[n.x], l = 0, a = e.length; l < a; l++) {
          if (r.charCodeAt(n.y + l) !== e.charCodeAt(l)) {
            return null;
          }
        }
        n.y += e.length;
        return e;
      }
    };
  }(e) : function D(e) {
    e = r ? new RegExp(e.source, "y") : new RegExp(e.source + "|()", "g");
    return function(n) {
      if (n.x < n.quasis.length) {
        var l = n.quasis[n.x];
        e.lastIndex = n.y;
        var a;
        r ? e.test(l) && (a = l.slice(n.y, e.lastIndex)) : null == (l = e.exec(l))[1] && (a = l[0]);
        n.y = e.lastIndex;
        return a;
      }
    };
  }(e);
}

function parse$1(e) {
  return function(n) {
    var r = arguments;
    for (var l = [], a = arguments.length - 1; 0 < a--; ) {
      l[a] = r[a + 1];
    }
    "string" == typeof n && (n = [ n ]);
    return e({
      quasis: n,
      expressions: l,
      x: 0,
      y: 0
    });
  };
}

var l = E(/[_\w][_\d\w]*/);

var name = function(n) {
  var r = n.y, a = n.x;
  var i = [];
  var u;
  if (null != (u = l(n))) {
    i.push(u);
  } else {
    n.y = r;
    n.x = a;
    return {
      kind: i.tag,
      value: i[0]
    };
  }
  if (e.NAME) {
    i.tag = e.NAME;
  }
  return {
    kind: i.tag,
    value: i[0]
  };
};

var a = E("null");

var i = E(/true|false/);

var u = E("$");

var variable = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  if (null == u(n)) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0]
    };
  }
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0]
    };
  }
  if (e.VARIABLE) {
    a.tag = e.VARIABLE;
  }
  return {
    kind: a.tag,
    name: a[0]
  };
};

var t = E(/[-]?\d+/), y = E(/[.]\d+/), x = E(/[eE][+-]?\d+/);

var v = E('"""'), s = E(/.*(?=""")/), f = E('"""'), g = E('"'), d = E(/[^"\r\n]*/), o = E('"');

var k = E("["), h = E(/([\s,]|#[^\n\r]+)+/), p = E("]");

var c = E(":");

var objectField = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      value: a[1]
    };
  }
  var y = n.y, x = n.x;
  if (null == (i = h(n))) {
    n.y = y;
    n.x = x;
  }
  if (null == (i = c(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      value: a[1]
    };
  }
  if (null != (i = value(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      value: a[1]
    };
  }
  if (e.OBJECT_FIELD) {
    a.tag = e.OBJECT_FIELD;
  }
  return {
    kind: a.tag,
    name: a[0],
    value: a[1]
  };
};

var N = E("{"), b = E("}");

var value = function(n) {
  var r = n.y, l = n.x;
  var u = [];
  var c;
  var I = n.y, T = n.x;
  if (null == (c = h(n))) {
    n.y = I;
    n.x = T;
  }
  var m = u.length;
  e: {
    n: {
      var A = n.y, O = n.x;
      if (null != (c = function(n) {
        var r = n.y, l = n.x;
        var i = [];
        var u;
        if (null != (u = a(n))) {
          i.push(u);
        } else {
          n.y = r;
          n.x = l;
          return {
            kind: i.tag
          };
        }
        if (e.NULL) {
          i.tag = e.NULL;
        }
        return {
          kind: i.tag
        };
      }(n))) {
        u.push(c);
      } else {
        n.y = A;
        n.x = O;
        u.length = m;
        break n;
      }
      break e;
    }
    n: {
      A = n.y, O = n.x;
      if (null != (c = function(n) {
        var r = n.y, l = n.x;
        var a = [];
        var u;
        if (null != (u = i(n))) {
          a.push(u);
        } else {
          n.y = r;
          n.x = l;
          return {
            kind: a.tag,
            value: "true" === a[0]
          };
        }
        if (e.BOOLEAN) {
          a.tag = e.BOOLEAN;
        }
        return {
          kind: a.tag,
          value: "true" === a[0]
        };
      }(n))) {
        u.push(c);
      } else {
        n.y = A;
        n.x = O;
        u.length = m;
        break n;
      }
      break e;
    }
    n: {
      A = n.y, O = n.x;
      if (null != (c = variable(n))) {
        u.push(c);
      } else {
        n.y = A;
        n.x = O;
        u.length = m;
        break n;
      }
      break e;
    }
    n: {
      A = n.y, O = n.x;
      if (null != (c = function(n) {
        var r = n.y, l = n.x;
        var a = [];
        var i;
        r: {
          l: {
            var u = n.y, t = n.x;
            var y = a.length;
            if (null == (i = v(n))) {
              n.y = u;
              n.x = t;
              a.length = y;
              break l;
            }
            if (null != (i = s(n))) {
              a.push(i);
            } else {
              n.y = u;
              n.x = t;
              a.length = y;
              break l;
            }
            if (null == (i = f(n))) {
              n.y = u;
              n.x = t;
              a.length = y;
              break l;
            }
            break r;
          }
          y = a.length;
          if (null == (i = g(n))) {
            n.y = r;
            n.x = l;
            a.length = y;
            return {
              kind: a.tag,
              value: a[0]
            };
          }
          if (null != (i = d(n))) {
            a.push(i);
          } else {
            n.y = r;
            n.x = l;
            a.length = y;
            return {
              kind: a.tag,
              value: a[0]
            };
          }
          if (null == (i = o(n))) {
            n.y = r;
            n.x = l;
            a.length = y;
            return {
              kind: a.tag,
              value: a[0]
            };
          }
        }
        if (e.STRING) {
          a.tag = e.STRING;
        }
        return {
          kind: a.tag,
          value: a[0]
        };
      }(n))) {
        u.push(c);
      } else {
        n.y = A;
        n.x = O;
        u.length = m;
        break n;
      }
      break e;
    }
    n: {
      A = n.y, O = n.x;
      if (null != (c = function(n) {
        var r = n.y, l = n.x;
        var a = [];
        var i;
        if (null != (i = t(n))) {
          a.push(i);
        } else {
          n.y = r;
          n.x = l;
          return {
            kind: 1 === a.length ? e.INT : e.FLOAT,
            value: a.join("")
          };
        }
        var u = n.y, v = n.x;
        if (null != (i = y(n))) {
          a.push(i);
        } else {
          n.y = u;
          n.x = v;
        }
        u = n.y, v = n.x;
        if (null != (i = x(n))) {
          a.push(i);
        } else {
          n.y = u;
          n.x = v;
        }
        return {
          kind: 1 === a.length ? e.INT : e.FLOAT,
          value: a.join("")
        };
      }(n))) {
        u.push(c);
      } else {
        n.y = A;
        n.x = O;
        u.length = m;
        break n;
      }
      break e;
    }
    n: {
      A = n.y, O = n.x;
      if (null != (c = function(n) {
        var r = n.y, l = n.x;
        var a = [];
        var i;
        if (null != (i = name(n))) {
          a.push(i);
        } else {
          n.y = r;
          n.x = l;
          return {
            kind: a.tag,
            value: a[0].value
          };
        }
        if (e.ENUM) {
          a.tag = e.ENUM;
        }
        return {
          kind: a.tag,
          value: a[0].value
        };
      }(n))) {
        u.push(c);
      } else {
        n.y = A;
        n.x = O;
        u.length = m;
        break n;
      }
      break e;
    }
    n: {
      A = n.y, O = n.x;
      if (null != (c = function(n) {
        var r = n.y, l = n.x;
        var a = [];
        var i;
        if (null == (i = k(n))) {
          n.y = r;
          n.x = l;
          return {
            kind: a.tag,
            values: a.slice()
          };
        }
        r: for (;;) {
          var u = n.y, t = n.x;
          if (null != (i = value(n))) {
            a.push(i);
          } else {
            n.y = u;
            n.x = t;
            break r;
          }
        }
        var y = n.y, x = n.x;
        if (null == (i = h(n))) {
          n.y = y;
          n.x = x;
        }
        if (null == (i = p(n))) {
          n.y = r;
          n.x = l;
          return {
            kind: a.tag,
            values: a.slice()
          };
        }
        y = n.y, x = n.x;
        if (null == (i = h(n))) {
          n.y = y;
          n.x = x;
        }
        if (e.LIST) {
          a.tag = e.LIST;
        }
        return {
          kind: a.tag,
          values: a.slice()
        };
      }(n))) {
        u.push(c);
      } else {
        n.y = A;
        n.x = O;
        u.length = m;
        break n;
      }
      break e;
    }
    if (null != (c = function(n) {
      var r = n.y, l = n.x;
      var a = [];
      var i;
      if (null == (i = N(n))) {
        n.y = r;
        n.x = l;
        return {
          kind: a.tag,
          fields: a.slice()
        };
      }
      n: for (;;) {
        var u = n.y, t = n.x;
        if (null != (i = objectField(n))) {
          a.push(i);
        } else {
          n.y = u;
          n.x = t;
          break n;
        }
      }
      if (null == (i = b(n))) {
        n.y = r;
        n.x = l;
        return {
          kind: a.tag,
          fields: a.slice()
        };
      }
      var y = n.y, x = n.x;
      if (null == (i = h(n))) {
        n.y = y;
        n.x = x;
      }
      if (e.OBJECT) {
        a.tag = e.OBJECT;
      }
      return {
        kind: a.tag,
        fields: a.slice()
      };
    }(n))) {
      u.push(c);
    } else {
      n.y = r;
      n.x = l;
      u.length = m;
      return;
    }
  }
  I = n.y, T = n.x;
  if (null == (c = h(n))) {
    n.y = I;
    n.x = T;
  }
  return function(e) {
    return e[0];
  }(u);
};

var I = E(":");

var arg = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      value: a[1]
    };
  }
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null == (i = I(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      value: a[1]
    };
  }
  u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null != (i = value(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      value: a[1]
    };
  }
  if (e.ARGUMENT) {
    a.tag = e.ARGUMENT;
  }
  return {
    kind: a.tag,
    name: a[0],
    value: a[1]
  };
};

var T = E("("), m = E(")");

var args = function(e) {
  var n = [];
  var r;
  var l = e.y, a = e.x;
  if (null == (r = h(e))) {
    e.y = l;
    e.x = a;
  }
  e: {
    l = e.y, a = e.x;
    var i = n.length;
    if (null == (r = T(e))) {
      e.y = l;
      e.x = a;
      n.length = i;
      break e;
    }
    var u = e.y, t = e.x;
    if (null == (r = h(e))) {
      e.y = u;
      e.x = t;
    }
    if (null != (r = arg(e))) {
      n.push(r);
    } else {
      e.y = l;
      e.x = a;
      n.length = i;
      break e;
    }
    n: for (;;) {
      var y = e.y, x = e.x;
      if (null != (r = arg(e))) {
        n.push(r);
      } else {
        e.y = y;
        e.x = x;
        break n;
      }
    }
    if (null == (r = m(e))) {
      e.y = l;
      e.x = a;
      n.length = i;
      break e;
    }
    u = e.y, t = e.x;
    if (null == (r = h(e))) {
      e.y = u;
      e.x = t;
    }
  }
  return n;
};

var A = E("@");

var directive = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  if (null == (i = A(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      arguments: a[1]
    };
  }
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      arguments: a[1]
    };
  }
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  u = n.y, t = n.x;
  if (null != (i = args(n))) {
    a.push(i);
  } else {
    n.y = u;
    n.x = t;
  }
  u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (e.DIRECTIVE) {
    a.tag = e.DIRECTIVE;
  }
  return {
    kind: a.tag,
    name: a[0],
    arguments: a[1]
  };
};

var directives = function(e) {
  var n = [];
  var r;
  var l = e.y, a = e.x;
  if (null == (r = h(e))) {
    e.y = l;
    e.x = a;
  }
  e: for (;;) {
    l = e.y, a = e.x;
    if (null != (r = directive(e))) {
      n.push(r);
    } else {
      e.y = l;
      e.x = a;
      break e;
    }
  }
  return n;
};

var O = E(":");

var field = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  e: {
    u = n.y, t = n.x;
    var y = a.length;
    var x = n.y, v = n.x;
    if (null == (i = h(n))) {
      n.y = x;
      n.x = v;
    }
    if (null == (i = O(n))) {
      n.y = u;
      n.x = t;
      a.length = y;
      break e;
    }
    x = n.y, v = n.x;
    if (null == (i = h(n))) {
      n.y = x;
      n.x = v;
    }
    if (null != (i = name(n))) {
      a.push(i);
    } else {
      n.y = u;
      n.x = t;
      a.length = y;
      break e;
    }
  }
  if (null != (i = args(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  if (null != (i = directives(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  u = n.y, t = n.x;
  if (null != (i = selectionSet(n))) {
    a.push(i);
  } else {
    n.y = u;
    n.x = t;
  }
  if (e.FIELD) {
    a.tag = e.FIELD;
  }
  return function(n) {
    var r = 0;
    return {
      kind: n.tag,
      alias: n[1].kind === e.NAME ? n[r++] : void 0,
      name: n[r++],
      arguments: n[r++],
      directives: n[r++],
      selectionSet: n[r++]
    };
  }(a);
};

var L = E("["), _ = E("]"), S = E("!");

var type = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  var u = a.length;
  e: {
    n: {
      var t = n.y, y = n.x;
      if (null == (i = L(n))) {
        n.y = t;
        n.x = y;
        a.length = u;
        break n;
      }
      var x = n.y, v = n.x;
      if (null == (i = h(n))) {
        n.y = x;
        n.x = v;
      }
      if (null != (i = type(n))) {
        a.push(i);
      } else {
        n.y = t;
        n.x = y;
        a.length = u;
        break n;
      }
      x = n.y, v = n.x;
      if (null == (i = h(n))) {
        n.y = x;
        n.x = v;
      }
      if (null == (i = _(n))) {
        n.y = t;
        n.x = y;
        a.length = u;
        break n;
      }
      x = n.y, v = n.x;
      if (null == (i = h(n))) {
        n.y = x;
        n.x = v;
      }
      break e;
    }
    if (null != (i = name(n))) {
      a.push(i);
    } else {
      n.y = r;
      n.x = l;
      a.length = u;
      return;
    }
  }
  var s = n.y, f = n.x;
  if (null != (i = S(n))) {
    a.push(i);
  } else {
    n.y = s;
    n.x = f;
  }
  s = n.y, f = n.x;
  if (null == (i = h(n))) {
    n.y = s;
    n.x = f;
  }
  return function(n) {
    var r = "Name" === n[0].kind ? {
      kind: e.NAMED_TYPE,
      name: n[0]
    } : {
      kind: e.LIST_TYPE,
      type: n[0]
    };
    return "!" === n[1] ? {
      kind: e.NON_NULL_TYPE,
      type: r
    } : r;
  }(a);
};

var R = E("on");

var typeCondition = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null == (i = R(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: e.NAMED_TYPE,
      name: a[0]
    };
  }
  if (null == (i = h(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: e.NAMED_TYPE,
      name: a[0]
    };
  }
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: e.NAMED_TYPE,
      name: a[0]
    };
  }
  var y = n.y, x = n.x;
  if (null == (i = h(n))) {
    n.y = y;
    n.x = x;
  }
  return {
    kind: e.NAMED_TYPE,
    name: a[0]
  };
};

var M = E("...");

var inlineFragment = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  if (null == (i = M(n))) {
    n.y = r;
    n.x = l;
    return;
  }
  var u = n.y, t = n.x;
  if (null != (i = typeCondition(n))) {
    a.push(i);
  } else {
    n.y = u;
    n.x = t;
  }
  if (null != (i = directives(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  if (null != (i = selectionSet(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  if (e.INLINE_FRAGMENT) {
    a.tag = e.INLINE_FRAGMENT;
  }
  return function(n) {
    var r = 0;
    return {
      kind: n.tag,
      typeCondition: n[r].kind === e.NAMED_TYPE ? n[r++] : void 0,
      directives: n[r++],
      selectionSet: n[r]
    };
  }(a);
};

var F = E("..."), P = E("on");

var fragmentSpread = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  if (null == (i = F(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      directives: a[1]
    };
  }
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  e: {
    var y = n.y, x = n.x;
    if (null == (i = P(n))) {
      n.y = y;
      n.x = x;
      break e;
    }
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      directives: a[1]
    };
  }
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      directives: a[1]
    };
  }
  y = n.y, x = n.x;
  if (null == (i = h(n))) {
    n.y = y;
    n.x = x;
  }
  if (null != (i = directives(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      directives: a[1]
    };
  }
  if (e.FRAGMENT_SPREAD) {
    a.tag = e.FRAGMENT_SPREAD;
  }
  return {
    kind: a.tag,
    name: a[0],
    directives: a[1]
  };
};

var V = E("{"), G = E("}");

var selectionSet = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null == (i = V(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      selections: a.slice()
    };
  }
  var y = n.y, x = n.x;
  if (null == (i = h(n))) {
    n.y = y;
    n.x = x;
  }
  var v = a.length;
  e: {
    n: {
      y = n.y, x = n.x;
      if (null != (i = inlineFragment(n))) {
        a.push(i);
      } else {
        n.y = y;
        n.x = x;
        a.length = v;
        break n;
      }
      break e;
    }
    n: {
      y = n.y, x = n.x;
      if (null != (i = fragmentSpread(n))) {
        a.push(i);
      } else {
        n.y = y;
        n.x = x;
        a.length = v;
        break n;
      }
      break e;
    }
    if (null != (i = field(n))) {
      a.push(i);
    } else {
      n.y = r;
      n.x = l;
      a.length = v;
      return {
        kind: a.tag,
        selections: a.slice()
      };
    }
  }
  e: for (;;) {
    u = n.y, t = n.x;
    v = a.length;
    n: {
      r: {
        y = n.y, x = n.x;
        if (null != (i = inlineFragment(n))) {
          a.push(i);
        } else {
          n.y = y;
          n.x = x;
          a.length = v;
          break r;
        }
        break n;
      }
      r: {
        y = n.y, x = n.x;
        if (null != (i = fragmentSpread(n))) {
          a.push(i);
        } else {
          n.y = y;
          n.x = x;
          a.length = v;
          break r;
        }
        break n;
      }
      if (null != (i = field(n))) {
        a.push(i);
      } else {
        n.y = u;
        n.x = t;
        a.length = v;
        break e;
      }
    }
  }
  if (null == (i = G(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      selections: a.slice()
    };
  }
  y = n.y, x = n.x;
  if (null == (i = h(n))) {
    n.y = y;
    n.x = x;
  }
  if (e.SELECTION_SET) {
    a.tag = e.SELECTION_SET;
  }
  return {
    kind: a.tag,
    selections: a.slice()
  };
};

var w = E("=");

var U = E(":");

var varDefinition = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  if (null != (i = variable(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      variable: a[0],
      type: a[1],
      defaultValue: a[2].kind ? a[2] : void 0,
      directives: !a[2].kind ? a[2] : a[3]
    };
  }
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null == (i = U(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      variable: a[0],
      type: a[1],
      defaultValue: a[2].kind ? a[2] : void 0,
      directives: !a[2].kind ? a[2] : a[3]
    };
  }
  u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null != (i = type(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      variable: a[0],
      type: a[1],
      defaultValue: a[2].kind ? a[2] : void 0,
      directives: !a[2].kind ? a[2] : a[3]
    };
  }
  var y = n.y, x = n.x;
  if (null != (i = function(e) {
    var n = e.y, r = e.x;
    var l = [];
    var a;
    if (null == w(e)) {
      e.y = n;
      e.x = r;
      return;
    }
    var i = e.y, u = e.x;
    if (null == h(e)) {
      e.y = i;
      e.x = u;
    }
    if (null != (a = value(e))) {
      l.push(a);
    } else {
      e.y = n;
      e.x = r;
      return;
    }
    return function(e) {
      return e[0];
    }(l);
  }(n))) {
    a.push(i);
  } else {
    n.y = y;
    n.x = x;
  }
  if (null != (i = directives(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      variable: a[0],
      type: a[1],
      defaultValue: a[2].kind ? a[2] : void 0,
      directives: !a[2].kind ? a[2] : a[3]
    };
  }
  y = n.y, x = n.x;
  if (null == (i = h(n))) {
    n.y = y;
    n.x = x;
  }
  if (e.VARIABLE_DEFINITION) {
    a.tag = e.VARIABLE_DEFINITION;
  }
  return {
    kind: a.tag,
    variable: a[0],
    type: a[1],
    defaultValue: a[2].kind ? a[2] : void 0,
    directives: !a[2].kind ? a[2] : a[3]
  };
};

var q = E("("), Y = E(")");

var $ = E("fragment");

var fragmentDefinition = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null == (i = $(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      typeCondition: a[1],
      directives: a[2],
      selectionSet: a[3]
    };
  }
  if (null == (i = h(n))) {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      typeCondition: a[1],
      directives: a[2],
      selectionSet: a[3]
    };
  }
  if (null != (i = name(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      typeCondition: a[1],
      directives: a[2],
      selectionSet: a[3]
    };
  }
  if (null != (i = typeCondition(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      typeCondition: a[1],
      directives: a[2],
      selectionSet: a[3]
    };
  }
  if (null != (i = directives(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      typeCondition: a[1],
      directives: a[2],
      selectionSet: a[3]
    };
  }
  if (null != (i = selectionSet(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      name: a[0],
      typeCondition: a[1],
      directives: a[2],
      selectionSet: a[3]
    };
  }
  if (e.FRAGMENT_DEFINITION) {
    a.tag = e.FRAGMENT_DEFINITION;
  }
  return {
    kind: a.tag,
    name: a[0],
    typeCondition: a[1],
    directives: a[2],
    selectionSet: a[3]
  };
};

var j = E(/query|mutation|subscription/);

var operationDefinition = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  var u = n.y, t = n.x;
  if (null == (i = h(n))) {
    n.y = u;
    n.x = t;
  }
  if (null != (i = j(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  e: {
    u = n.y, t = n.x;
    var y = a.length;
    if (null == (i = h(n))) {
      n.y = u;
      n.x = t;
      a.length = y;
      break e;
    }
    if (null != (i = name(n))) {
      a.push(i);
    } else {
      n.y = u;
      n.x = t;
      a.length = y;
      break e;
    }
  }
  u = n.y, t = n.x;
  if (null != (i = function(e) {
    var n = e.y, r = e.x;
    var l = [];
    var a;
    var i = e.y, u = e.x;
    if (null == (a = h(e))) {
      e.y = i;
      e.x = u;
    }
    if (null == (a = q(e))) {
      e.y = n;
      e.x = r;
      return;
    }
    var t = e.y, y = e.x;
    if (null == (a = h(e))) {
      e.y = t;
      e.x = y;
    }
    if (null != (a = varDefinition(e))) {
      l.push(a);
    } else {
      e.y = n;
      e.x = r;
      return;
    }
    e: for (;;) {
      i = e.y, u = e.x;
      if (null != (a = varDefinition(e))) {
        l.push(a);
      } else {
        e.y = i;
        e.x = u;
        break e;
      }
    }
    if (null == (a = Y(e))) {
      e.y = n;
      e.x = r;
      return;
    }
    t = e.y, y = e.x;
    if (null == (a = h(e))) {
      e.y = t;
      e.x = y;
    }
    l.tag = "vars";
    return l;
  }(n))) {
    a.push(i);
  } else {
    n.y = u;
    n.x = t;
  }
  if (null != (i = directives(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  if (null != (i = selectionSet(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return;
  }
  if (e.OPERATION_DEFINITION) {
    a.tag = e.OPERATION_DEFINITION;
  }
  return function(n) {
    var r = 1;
    return {
      kind: n.tag,
      operation: n[0],
      name: n[r].kind === e.NAME ? n[r++] : void 0,
      variableDefinitions: "vars" === n[r].tag ? n[r++].slice() : [],
      directives: n[r++],
      selectionSet: n[r]
    };
  }(a);
};

var queryShorthand = function(n) {
  var r = n.y, l = n.x;
  var a = [];
  var i;
  if (null != (i = selectionSet(n))) {
    a.push(i);
  } else {
    n.y = r;
    n.x = l;
    return {
      kind: a.tag,
      operation: "query",
      name: void 0,
      variableDefinitions: [],
      directives: [],
      selectionSet: a[0]
    };
  }
  if (e.OPERATION_DEFINITION) {
    a.tag = e.OPERATION_DEFINITION;
  }
  return {
    kind: a.tag,
    operation: "query",
    name: void 0,
    variableDefinitions: [],
    directives: [],
    selectionSet: a[0]
  };
};

var J = parse$1((function(n) {
  var r = [];
  var l;
  e: for (;;) {
    var a = n.y, i = n.x;
    var u = r.length;
    n: {
      r: {
        var t = n.y, y = n.x;
        if (null != (l = queryShorthand(n))) {
          r.push(l);
        } else {
          n.y = t;
          n.x = y;
          r.length = u;
          break r;
        }
        break n;
      }
      r: {
        t = n.y, y = n.x;
        if (null != (l = operationDefinition(n))) {
          r.push(l);
        } else {
          n.y = t;
          n.x = y;
          r.length = u;
          break r;
        }
        break n;
      }
      if (null != (l = fragmentDefinition(n))) {
        r.push(l);
      } else {
        n.y = a;
        n.x = i;
        r.length = u;
        break e;
      }
    }
  }
  if (e.DOCUMENT) {
    r.tag = e.DOCUMENT;
  }
  return function(e) {
    return e.length ? {
      kind: e.tag,
      definitions: e.slice()
    } : void 0;
  }(r);
}));

var Q = parse$1(value);

var z = parse$1(type);

function parse(e) {
  var r = J(e);
  if (null == r) {
    throw new n("Syntax Error");
  }
  return r;
}

function parseValue(e) {
  var r = Q(e);
  if (null == r) {
    throw new n("Syntax Error");
  }
  return r;
}

function parseType(e) {
  var r = z(e);
  if (null == r) {
    throw new n("Syntax Error");
  }
  return r;
}

export { parse, parseType, parseValue };
