"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var t = require("./location.js");

function printSourceLocation$1(t, n) {
  return t.name + ":" + (n.line + t.locationOffset.line - 1) + ":" + (n.column + n.line === 1 ? t.locationOffset.column - 1 : 0);
}

function printSourceLocation(t, n) {
  var r = t.locationOffset.column - 1;
  var o = "".padStart(r) + t.body;
  var e = n.line - 1;
  var i = n.line + (t.locationOffset.line - 1);
  var a = n.column + (1 === n.line ? r : 0);
  var c = t.name + ":" + i + ":" + a + "\n";
  var u = o.split(/\r\n|[\n\r]/g);
  var p = u[e];
  if (p.length > 120) {
    var l = Math.floor(a / 80);
    var s = a % 80;
    var f = [];
    for (var v = 0; v < p.length; v += 80) {
      f.push(p.slice(v, v + 80));
    }
    return c + printPrefixedLines([ [ i + " |", f[0] ] ].concat(f.slice(1, l + 1).map((function(t) {
      return [ "|", t ];
    })), [ [ "|", "^".padStart(s) ] ], [ [ "|", f[l + 1] ] ]));
  }
  return c + printPrefixedLines([ [ i - 1 + " |", u[e - 1] ], [ i + " |", p ], [ "|", "^".padStart(a) ], [ i + 1 + " |", u[e + 1] ] ]);
}

function printPrefixedLines(t) {
  var n = t.filter((function(t) {
    return void 0 !== t[1];
  }));
  var r = Math.max.apply(Math, n.map((function(t) {
    return t[0].length;
  })));
  return n.map((function(t) {
    var n = t[1];
    return t[0].padStart(r) + (n ? " " + n : "");
  })).join("\n");
}

exports.printLocation = function printLocation$1(n) {
  return printSourceLocation$1(n.source, t.getLocation(n.source, n.start));
};

exports.printLocation$1 = function printLocation(n) {
  return printSourceLocation(n.source, t.getLocation(n.source, n.start));
};

exports.printSourceLocation = printSourceLocation$1;

exports.printSourceLocation$1 = printSourceLocation;
