"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = {};

function getVisitFn(e, r, i) {
  var t = e[r];
  if (t) {
    if ("function" == typeof t) {
      return i ? void 0 : t;
    }
    return i ? t.leave : t.enter;
  }
  return i ? e.leave : e.enter;
}

exports.BREAK = e;

exports.getVisitFn = getVisitFn;

exports.visit = function visit(r, i) {
  var t = [];
  var n = [];
  function callback(r, l, a, v) {
    var f = getVisitFn(i, r.kind, v);
    if (f) {
      var s = f.call(i, r, l, a, t, n);
      if (s === e) {
        throw e;
      }
      return s;
    }
  }
  try {
    var l = function traverse(e, r, i) {
      var l = !1;
      var a = callback(e, r, i, !1);
      if (!1 === a) {
        return e;
      } else if (null === a) {
        return null;
      } else if (a && "string" == typeof a.kind) {
        l = a !== e;
        e = a;
      }
      if (i) {
        n.push(i);
      }
      var v;
      var f = Object.assign({}, e);
      for (var s in e) {
        t.push(s);
        var u = e[s];
        if (Array.isArray(u)) {
          var o = [];
          for (var p = 0; p < u.length; p++) {
            if (null != u[p] && "string" == typeof u[p].kind) {
              n.push(e);
              t.push(p);
              v = traverse(u[p], p, u);
              t.pop();
              n.pop();
              if (void 0 === v) {
                o.push(u[p]);
              } else if (null === v) {
                l = !0;
              } else {
                l = l || v !== u[p];
                o.push(v);
              }
            }
          }
          u = o;
        } else if (null != u && "string" == typeof u.kind) {
          if (void 0 !== (v = traverse(u, s, e))) {
            l = l || u !== v;
            u = v;
          }
        }
        t.pop();
        if (l) {
          f[s] = u;
        }
      }
      if (i) {
        n.pop();
      }
      var c = callback(e, r, i, !0);
      if (void 0 !== c) {
        return c;
      } else if (void 0 !== a) {
        return a;
      } else {
        return l ? f : e;
      }
    }(r);
    return void 0 !== l && !1 !== l ? l : r;
  } catch (i) {
    if (i !== e) {
      throw i;
    }
    return r;
  }
};

exports.visitInParallel = function visitInParallel(r) {
  var i = new Array(r.length);
  return {
    enter: function enter() {
      var t = [], n = arguments.length;
      while (n--) {
        t[n] = arguments[n];
      }
      var l = t[0];
      for (var a = 0; a < r.length; a++) {
        if (null == i[a]) {
          var v = getVisitFn(r[a], l.kind, !1);
          if (v) {
            var f = v.apply(r[a], t);
            if (!1 === f) {
              i[a] = l;
            } else if (f === e) {
              i[a] = e;
            } else if (void 0 !== f) {
              return f;
            }
          }
        }
      }
    },
    leave: function leave() {
      var t = [], n = arguments.length;
      while (n--) {
        t[n] = arguments[n];
      }
      var l = t[0];
      for (var a = 0; a < r.length; a++) {
        if (null == i[a]) {
          var v = getVisitFn(r[a], l.kind, !0);
          if (v) {
            var f = v.apply(r[a], t);
            if (f === e) {
              i[a] = e;
            } else if (void 0 !== f && !1 !== f) {
              return f;
            }
          }
        } else if (i[a] === l) {
          i[a] = null;
        }
      }
    }
  };
};
